(* Copyright (c) 2011 - 2015. Cary Jensen, Jensen Data Systems, Inc.
   This code sample is intended for the readers of
   "Delphi in Depth: ClientDataSets"
     and
   "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen

   No guarantees or warranties are expressed or implied concerning
   the applicability of techniques or code included in this example
   or in the accompanying book. If you wish to use techniques or
   code included in this example or described in the book, it is
   your responsibility to test and certify any code, techniques,
   or design you adopt.

   For information on consulting or training services, please visit:
   http://www.JensenDataSystems.com

   For more information about "Delphi in Depth: ClientDataSets 2nd Edition"
   by Cary Jensen, including links to order the book, please visit:
   http://www.JensenDataSystems.com/cdsbook2
*)
unit mainformu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, ExtCtrls, DBCtrls, DBClient;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1InvoiceNo: TStringField;
    ClientDataSet1PartNo: TStringField;
    ClientDataSet1Price: TCurrencyField;
    ClientDataSet1Quantity: TIntegerField;
    ClientDataSet1Total: TCurrencyField;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClientDataSet1CalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ClientDataSet1CalcFields(DataSet: TDataSet);
begin
 ClientDataSet1Total.AsCurrency :=
   ClientDataSet1Price.AsCurrency * ClientDataSet1Quantity.AsInteger;
  //If there were additional InternalCalc or Calculated fields in
  //this ClientDataSet, you would perform those calculations here.
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ClientDataSet1.ChangeCount > 0 then
    ClientDataSet1.SaveToFile();
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  DataFile = 'data.xml';
begin
  ClientDataSet1.FileName :=
    ExtractFilePath(Application.ExeName) + DataFile;
  if FileExists(ClientDataSet1.FileName) then
    ClientDataSet1.LoadFromFile
  else
    ClientDataSet1.CreateDataSet;
end;

end.
